Summary: LSB Desktop Test Suites
Name: lsb-test-desktop
Version: 3.1.0
Release: 10
License: GPL
Group: Development/Tools
Source: lsb-test-desktop-3.1.0.tar.gz
URL: http://www.linuxbase.org/test
#Prefix: %{_prefix}
BuildRoot: %{_tmppath}/%{name}-root
AutoReqProv: no
Requires: lsb-tet3-lite >= 3.7, python
BuildRequires: lsb-tet3-lite-devel, lsb-build-desktop >= 3.0.0, lsb-build-qt4 >= 3.0.0, lsb-build-qt3 >= 3.0.0
%define	tet_root	%{_libdir}/tet

%description

This is a binary version of the LSB desktop test suites. 

#==================================================
%prep

set -x

%setup -q -c 

# %setup -D -b 1 -c
# %setup -D -b 2 -c
# %setup -D -b 3 -c


#==================================================
%build

TET_ROOT=`pwd`/lsb-desktop-test
TET_PATH=/opt/lsb-tet3-lite
PATH=/opt/lsb/bin:$PATH:$TET_PATH/bin
QMAKESPEC=/opt/lsb/mkspecs/linux-lsb
export TET_ROOT TET_PATH PATH QMAKESPEC

export CC=lsbcc CXX="lsbc++" LSB_PRODUCT=desktop 
for x in /opt/lsb/lib*/pkgconfig; do
	PKG_CONFIG_PATH="${x}${PKG_CONFIG_PATH+:${PKG_CONFIG_PATH}}"
done
export PKG_CONFIG_PATH

# tetj wrappers used for qt4 and xml
cd lsb-desktop-test/tests/misc/tetj
make

# Qt3 tests
cd ../../../lsb-qt3
LSBHOME="${RPM_BUILD_DIR}/lsb-test-desktop-3.1.0/lsb-desktop-test" TET_SUITE_ROOT="${TET_ROOT}" TET_ROOT="${TET_PATH}" tcc -p -b lsb-qt3

# Qt4 tests
cd ../lsb-qt
export LSB_MODULES=qt4
LSB_MODULES=qt4 LSBHOME="${RPM_BUILD_DIR}/lsb-test-desktop-3.1.0/lsb-desktop-test" /opt/lsb/bin/qmake
LSB_MODULES=qt4 LSBHOME="${RPM_BUILD_DIR}/lsb-test-desktop-3.1.0/lsb-desktop-test" make

# the gtkvts part
cd ../lsb-gtkvts
PATH=$PWD/deps/bin:$PATH ACLOCAL_FLAGS="-I $PWD/deps/share/aclocal $ACLOCAL_FLAGS" ./autogen.sh --with-no-hdr-tests=TRUE --with-no-doc-parsing=TRUE
make

cd ..

tcc -b -p lsb-gtkvts
# and now we verify it didn't fail, because tcc doesn't report build errors in tests.
set +x
failed=
cd lsb-gtkvts/tests/functions
for x in *; do 
	[ ! -e "$x/makefile" ] && continue		
	if [ ! -e "$x/$x" ]; then 
		echo "failed building gtkvts sub test $x"
		failed=1
	fi
done
set -x
[ -n "$failed" ] && exit 1

# the xml part
cd ../../../lsb-xml-test/lsb-xml2
LSBHOME=${RPM_BUILD_DIR}/lsb-test-desktop-3.1.0/lsb-desktop-test make -f Makefile.tests

# libpng tests
cd ../../lsb-libpng
LSBHOME="${RPM_BUILD_DIR}/lsb-test-desktop-3.1.0/lsb-desktop-test" make -f Makefile

#==================================================
%install

rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/bin

cp -pf lsb-desktop-test/scripts/runtime/run_tests ${RPM_BUILD_ROOT}/opt/lsb/test/desktop
cp -pf lsb-desktop-test/scripts/runtime/editcfg.sh ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/bin

# licensing

mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/doc/lsb-test-desktop
for lfile in License Artistic GPL; do cp -pf lsb-desktop-test/${lfile} ${RPM_BUILD_ROOT}/opt/lsb/doc/lsb-test-desktop; done

# the gtkvts part
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Widgets
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Resource_Files
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/GdkPixbuf/picfile
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/GdkPixbuf/tmpfile
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Glib
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/scenarios
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/results

cd lsb-desktop-test/lsb-gtkvts/

cp -pf tetexec.cfg ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tetexec.cfg
cp -pf tet_scen ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tet_scen
cp -pf scenarios/func_scen ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/scenarios/func_scen

for file in `find tests/functions -perm 755`; do
	dir_name=`dirname $file`
        mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/$dir_name
	cp -pf $file ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/$dir_name
done

#some special test cases need the following files
#cp -pf tests/functions/FileUtil/FileUtil.c ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tests/functions/FileUtil/FileUtil.c
#cp -pf tests/functions/GIOChannel/GIOChannel.c ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tests/functions/GIOChannel/GIOChannel.c
#cp -pf tests/functions/GtkFileSelection/GtkFileSelection.c ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tests/functions/GtkFileSelection/GtkFileSelection.c
install -D -m644 tests/functions/FileUtil/FileUtil.c ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tests/functions/FileUtil/FileUtil.c
install -D -m644 tests/functions/GIOChannel/GIOChannel.c ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tests/functions/GIOChannel/GIOChannel.c
install -D -m644 tests/functions/GtkFileSelection/GtkFileSelection.c ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/tests/functions/GtkFileSelection/GtkFileSelection.c
cp -pf src/tests/functions/Widgets/gnome-logo-icon.png ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Widgets/gnome-logo-icon.png
cp -pf src/tests/functions/Widgets/MyUI.xml ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Widgets/MyUI.xml
cp -pf src/tests/functions/Resource_Files/rc_example.rc ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Resource_Files/rc_example.rc
cp -prf src/tests/functions/GdkPixbuf/picfile/ ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/GdkPixbuf/
cp -prf src/tests/functions/GdkPixbuf/tmpfile/ ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/GdkPixbuf/
cp -prf src/tests/functions/Glib/casefold.txt ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Glib/casefold.txt
cp -prf src/tests/functions/Glib/casemap.txt ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/gtkvts/src/tests/functions/Glib/casemap.txt

cd ..

# fontconfig files and directories
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/fonts
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/tc
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/results

cd lsb-fontconfig/

cp -pf tetexec.cfg ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/tetexec.cfg
cp -pf tet_scen ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/tet_scen
cp -pf fonts.conf ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/fonts.conf
cp -pf out.expected ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/out.expected
cp -prf fonts ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/
cp -prf tc ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/fontconfig/

cd ..

# the xml part
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml/result
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml/test

cd lsb-xml-test/lsb-xml2

cp -pf lsb-rt-libxml2 ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml
cp -pf runtest ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml
cp -pf testapi ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml

cp -prf result ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml
cp -prf test ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/xml

#libpng
cd ../../lsb-libpng
mkdir -p "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/libpng/results"
mkdir -p "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/libpng/test"
cp -rpf imageSuite "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/libpng/"
cp -pf lsb-rt-libpng runtest "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/libpng/"

cd ../lsb-qt
for x in `find tests -type f -perm 755`; do
	install -D -m755 "$x" "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/Qt/$x"
done
cp -pf tet_scen "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/Qt/"
cp -pf tetexec.cfg "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/Qt/"
install -m755 lsb-rt-qt "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/Qt"

# qt3; install all tet_scen specified tests.
cd ../lsb-qt3
mkdir ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/qt3
mkdir ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/qt3/ts
mkdir ${RPM_BUILD_ROOT}/opt/lsb/test/desktop/qt3/ts/tests
for x in `find ts/tests -type f -perm 755`; do
	echo $x
	install -D -m755 $x "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/qt3/$x"
done
cp -pf tet_scen "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/qt3/tet_scen"
cp -pf tetexec.cfg "${RPM_BUILD_ROOT}/opt/lsb/test/desktop/qt3/tetexec.cfg"

cd ../

#==================================================
%clean
# uncomment later. leave in now for speed
if [ -n "${RPM_BUILD_ROOT}"  -a "${RPM_BUILD_ROOT}" != "/" ]; then 
    rm -rf ${RPM_BUILD_ROOT}
fi

#======================================================================
%pre

# Need to create some group and user beforehand because
# some test cases must run as non-root user.
groupadd lsb-desktop > /dev/null 2>&1 || true
useradd -g lsb-desktop lsb-desktop > /dev/null 2>&1 || true

#======================================================================
%post

echo
echo "Please make sure you have installed the necessary Xvfb package"
echo "(virtual frame buffer X server, whose name is something like"
echo "xvfb, XFree86-Xvfb or xorg-x11-Xvfb) and add the path which"
echo "includes the Xvfb executable binary to your PATH setting"
echo
echo "To run the tests, please execute the following command:"
echo "    cd /opt/lsb/test/desktop; ./run_tests"
echo
echo "You will need to run the tests as root."
echo

#======================================================================
%postun

userdel lsb-desktop > /dev/null 2>&1 || true
groupdel lsb-desktop > /dev/null 2>&1 || true

if [ -e /home/lsb-desktop ]; then
	rm -rf /home/lsb-desktop > /dev/null 2>&1 || true
fi

#==================================================
%files
%defattr(-,root,root)

/opt/lsb/test/desktop/run_tests
/opt/lsb/test/desktop/bin
/opt/lsb/doc

# the gtkvts part
%config(noreplace) /opt/lsb/test/desktop/gtkvts/tetexec.cfg

/opt/lsb/test/desktop/gtkvts/tet_scen
/opt/lsb/test/desktop/gtkvts/scenarios
/opt/lsb/test/desktop/gtkvts/tests
/opt/lsb/test/desktop/gtkvts/src

%dir /opt/lsb/test/desktop/gtkvts/results

# fontconfig
%config(noreplace) /opt/lsb/test/desktop/fontconfig/tetexec.cfg


/opt/lsb/test/desktop/fontconfig/tet_scen
/opt/lsb/test/desktop/fontconfig/fonts.conf
/opt/lsb/test/desktop/fontconfig/out.expected
/opt/lsb/test/desktop/fontconfig/tc
/opt/lsb/test/desktop/fontconfig/fonts

%dir /opt/lsb/test/desktop/fontconfig/results

# the xml part
/opt/lsb/test/desktop/xml/lsb-rt-libxml2
/opt/lsb/test/desktop/xml/runtest
/opt/lsb/test/desktop/xml/testapi
/opt/lsb/test/desktop/xml/result
/opt/lsb/test/desktop/xml/test

# png
/opt/lsb/test/desktop/libpng/lsb-rt-libpng
/opt/lsb/test/desktop/libpng/runtest
/opt/lsb/test/desktop/libpng/test
%dir /opt/lsb/test/desktop/libpng/imageSuite
/opt/lsb/test/desktop/libpng/imageSuite/*

# Qt
%dir /opt/lsb/test/desktop/Qt
/opt/lsb/test/desktop/Qt/*

# Qt3
/opt/lsb/test/desktop/qt3/tet_scen
/opt/lsb/test/desktop/qt3/tetexec.cfg
%dir /opt/lsb/test/desktop/qt3/ts
%dir /opt/lsb/test/desktop/qt3/ts/tests/
/opt/lsb/test/desktop/qt3/ts/tests/*

#==================================================
%changelog

* Thu May 25 2006 Marvin Heffler
- Increment release number to 10 for official respin of test package

* Fri May 19 2006 Marvin Heffler
- Increment release number to 9 due to rebuild with newer tet package

* Mon Apr 24 2006 Marvin Heffler
- Add /opt/lsb/doc directory to files list so it gets packaged

* Tue Feb 28 2006 Marvin Heffler
- Removed duplicate entry for tests subdirectory of Qt
